
import numpy as np
import matplotlib.pyplot as plt

# OUverture du fichier de coordonnées du point C
fichier=open('point_c.txt','r')
contenu=fichier.read()
lignes=contenu.split('\n')

t=[]
xC=[]
yC=[]
e=0.109
R=0.0792

# Calcul du facteur d'échelle
ech=e/236.9

# Création des vecteurs xA, yA, xB, yB, xC et yC
for ligne in lignes[:-2]:
    ligne=ligne.replace(',','.')
    data=ligne.split(';')
    t.append(float(data[0]))
    xC.append(ech*float(data[1]))
    yC.append(ech*float(data[2]))

xA=[0.]*len(t)
yA=[0.]*len(t)
xB=[0.]*len(t)
yB=[ech*236.9]*len(t)

t=np.array(t)
xA=np.array(xA)
yA=np.array(yA)
xB=np.array(xB)
yB=np.array(yB)
xC=np.array(xC)
yC=np.array(yC)

# Calcul des distances lAC et lBC
lAC=np.sqrt((xC-xA)**2+(yC-yA)**2)
lBC=np.sqrt((xC-xB)**2+(yC-yB)**2)
lAB=np.sqrt((xA-xB)**2+(yA-yB)**2)


# Calcul de theta_1_star à partir des données expérimentales
theta_1_star=np.arccos((xC-xA)/lAC)

# Tracé de theta_1_star
plt.figure('theta_1_star')
plt.plot(t,theta_1_star)

# Calcul de theta_2 à partir des données expérimentales
theta_2=np.arctan((yC-yB)/(xC-xB))

mod=0
for i,t_m in enumerate(theta_2):
    if t_m<-1 and mod==0:
        mod=np.pi
    if t_m>1 and mod==np.pi:
        mod=0
    theta_2[i]+=mod

# Calcul de theta_2 à partir de la fermeture géométrique
theta_2_model=theta_1_star-np.arcsin(e*np.cos(theta_1_star)/R)

# Tracé de theta_2
plt.figure('theta_2')
plt.plot(t,theta_2,t,theta_2_model)

# Calcul de lAC à partir de la fermeture géométrique
lAC_model=R*np.cos(theta_2)/np.cos(theta_1_star)

# Tracé de lAC
plt.figure('lAC')
plt.plot(t,lAC,t,lAC_model)

dt=t[1:]-t[:-1]
#Calcul de omega_1 à partir des données expérimentales
omega_1=(theta_1_star[1:]-theta_1_star[:-1])/dt

# Tracé de omega_1
plt.figure('omega_1')
plt.plot(t[:-1],omega_1)

#Calcul de omega_2 à partir des données expérimentales
omega_2=(theta_2[1:]-theta_2[:-1])/dt

#Calcul de omega_2 à partir de la fermeture cinématique
omega_2_model=(lAC[:-1]/lBC[:-1])*omega_1/np.cos(theta_2[:-1]-theta_1_star[:-1])

# Tracé de omega_2
plt.figure('omega_2')
plt.plot(t[:-1],omega_2,t[:-1],omega_2_model)


#Calcul de v=dlAC/dt à partir des données expérimentales
v=(lAC[1:]-lAC[:-1])/dt

#Calcul de v à partir de la fermeture cinématique
v_model=-lBC[:-1]*omega_2*np.sin(theta_2[:-1]-theta_1_star[:-1]);

# Tracé de v
plt.figure('v')
plt.plot(t[:-1],v,t[:-1],v_model)

plt.show()

